package server

import (
	"context"
	"net/http"
	"sync"

	events "bitbucket.org/_metalogic_/events-svc"
	_ "bitbucket.org/_metalogic_/events-svc/docs" // docs is generated by Swag CLI, you have to import it.
	httpSwagger "bitbucket.org/_metalogic_/httptreemux-swagger"
	"bitbucket.org/_metalogic_/log"
	"github.com/dimfeld/httptreemux/v5"
)

// EventsService ...
type EventsService struct {
	server   *http.Server
	listener events.Listener
	journal  events.Journal
}

func StartEventsServer(port, traceHeader string, l events.Listener, j events.Journal, wg *sync.WaitGroup) (svc *EventsService) {

	svc = &EventsService{
		server:   &http.Server{Addr: port, Handler: router(j, traceHeader)},
		listener: l,
		journal:  j,
	}

	// start the listener
	go func() {
		defer wg.Done() // let caller know we are done cleaning up

		err := l.Listen(j)
		if err != nil {
			log.Fatal(err)
		}
	}()

	// start the HTTP server
	go func() {
		defer wg.Done() // let main know we are done cleaning up

		// always returns error. ErrServerClosed on graceful close
		if err := svc.server.ListenAndServe(); err != http.ErrServerClosed {
			// unexpected error. port in use?
			log.Fatalf("ListenAndServe(): %v", err)
		}
	}()

	// returning reference so caller can call Shutdown()
	return svc
}

func (svc *EventsService) Shutdown(ctx context.Context) {
	svc.listener.Close()
	svc.journal.Close()
	if err := svc.server.Shutdown(ctx); err != nil {
		log.Fatal(err)
	}
	log.Warning("shutdown HTTP server")
}

// create the HTTP router for Service
func router(journal events.Journal, traceHeader string) *httptreemux.TreeMux {
	// initialize HTTP router
	treemux := httptreemux.New()
	api := treemux.NewGroup("/events-api/v1")
	// common endpoints
	api.GET("/admin/loglevel", LogLevel(journal))
	api.PUT("/admin/loglevel/:verbosity", SetLogLevel(journal))
	api.GET("/health", Health(journal))
	api.GET("/info", APIInfo(journal))
	api.GET("/stats", Stats(journal))
	api.GET("/openapi/*", httpSwagger.Handler(
		httpSwagger.URL("doc.json"), // The url pointing to API definition
		httpSwagger.DeepLinking(true),
		httpSwagger.DocExpansion("none"),
		httpSwagger.DomID("#swagger-ui")))

	// journal endpoints
	api.GET("/records", Records(journal))
	return treemux
}
